﻿# Why Refactor
Inline local variables are almost always used as part of _Replace Temp with Query_ or to pave the way for _Extract Method_.

# Benefits
This refactoring technique offers almost no benefit in and of itself. However, if the variable is assigned the result of a method, you can marginally improve the readability of the program by getting rid of the unnecessary variable.

# Drawbacks
Sometimes seemingly useless temps are used to cache the result of an expensive operation that is reused several times. So before using this refactoring technique, make sure that simplicity will not come at the cost of performance.

# How to Refactor
1. Find all places that use the variable. Instead of the variable, use the expression that had been assigned to it.
2. Delete the declaration of the variable and its assignment line.

# Sources
* https://sourcemaking.com/refactoring/inline-temp
* Martin Fowler, Kent Beck: Refactoring, Improving the Design of Existing Code 

# Rider Support
* Shortcut: Ctrl + Alt + N
* Refactor -> Inline -> Inline... 
* See: https://www.jetbrains.com/help/rider/Refactorings__Inline_Variable.html