﻿/*
 * Problem:
 *
 *        Multiple methods perform similar actions that are different only in their internal values, numbers or operations.
 *
 * Note: use related test for validation: RefactoringTechniquesTest._07_Parameterize_Method.orig.OrigTest
 */

using System;

namespace RefactoringTechniques._07_Parameterize_Method.orig
{
    public class Orig
    {
        public String BaseCharge(int usage)
        {
            if (usage < 0) return Usd(0);
            var amount = BottomBand(usage) * 0.03
                         + MiddleBand(usage) * 0.05
                         + TopBand(usage) * 0.07;
            return Usd(amount);
        }

        private int BottomBand(int usage)
        {
            return Math.Min(usage, 100);
        }

        private int MiddleBand(int usage)
        {
            return usage > 100 ? Math.Min(usage, 200) - 100 : 0;
        }

        private int TopBand(int usage)
        {
            return usage > 200 ? usage - 200 : 0;
        }

        private String Usd(double amount)
        {
            return "$" + amount;
        }
    }
}