﻿using System;

/*
 * Solution:
 *
 *           Decompose the complicated parts of the conditional into separate methods.
 */
namespace RefactoringTechniques._10_Decompose_Conditional.solved
{
    public class Solved
    {
        private readonly DateTime SUMMER_START = DateTime.Parse("01/07/2021");
        private readonly DateTime SUMMER_END = DateTime.Parse("01/07/2021");

        public int CountPrice(DateTime date, int quantity)
        {
            return IsWinter(date) ? CountWinterCharge(quantity) : CountSummerCharge(quantity);
        }

        private bool IsWinter(DateTime date)
        {
            return date < SUMMER_START || date > SUMMER_END;
        }

        private static int CountWinterCharge(int quantity)
        {
            const int winterRate = 120;
            const int winterServiceCharge = 20;
            return quantity * winterRate + winterServiceCharge;
        }

        private static int CountSummerCharge(int quantity)
        {
            const int summerRate = 80;
            return quantity * summerRate;
        }
    }
}