﻿# Why Refactor
The longer a piece of code is, the harder it is to understand. Things become even more hard to understand when the code is filled with conditions:
* While you are busy figuring out what the code in the then block does, you forget what the relevant condition was.
* While you are busy parsing else, you forget what the code in then does.

# Benefits
* By extracting conditional code to clearly named methods, you make life easier for the person who will be maintaining the code later (such as you, two months from now!).
* This refactoring technique is also applicable for short expressions in conditions. The string isSummer(date) is much prettier and more descriptive than code for comparing dates.

# Source
* https://sourcemaking.com/refactoring/decompose-conditional
* Martin Fowler, Kent Beck: Refactoring, Improving the Design of Existing Code

# Rider Support
* Shortcut: Ctrl + Alt + M
* Refactor -> Extract -> Extract method
* See: https://www.jetbrains.com/help/rider/Refactorings__Extract_Method.html