using NUnit.Framework;
using RefactoringTechniques._07_Parameterize_Method.orig;

namespace RefactoringTechniquesTest._07_Parameterize_Method.orig
{
    public class OrigTest
    {
        private Orig orig;

        [SetUp]
        public void Setup()
        {
            orig = new Orig();
        }

        [Test]
        public void WhenUsageZero_ThenBaseChargeIsZeroDollar()
        {
            Assert.AreEqual("$0", orig.BaseCharge(-5));
        }

        [Test]
        public void WhenUsageBottomBand_ThenBottomBandIsUsedForBaseCharge()
        {
            Assert.AreEqual("$0.3", orig.BaseCharge(10));
        }

        [Test]
        public void WhenUsageMiddleBand_ThenBottomAndMiddleBandsAreUsedForBaseCharge()
        {
            Assert.AreEqual("$3.5", orig.BaseCharge(110));
        }

        [Test]
        public void WhenUsageTopBand_ThenBottomMiddleTopBandsAreUsedForBaseCharge()
        {
            Assert.AreEqual("$8.7", orig.BaseCharge(210));
        }
    }
}